; ==============================================================================
;	Kanji Driver
;
;  Copyright (C) 2020 Takayuki Hara (HRA!)
;  All rights reserved.
;                           http://hraroom.s602.xrea.com/msx/software/mgsp.html
;
;  {\tgEFAі{\tgEFAɊÂč쐬ꂽh́Aȉ̏
;  ꍇɌAĔЕzюgp܂B
;
;  1.\[XR[h`ōĔЕzꍇAL̒쌠\A{ꗗAщL
;    Ɛӏ̂܂܂̌`ŕێ邱ƁB
;  2.oCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
;    쌠\A{ꗗAщLƐӏ܂߂邱ƁB
;  3.ʂɂ鎖ŐȂɁA{\tgEFA̔AяƓIȐi⊈
;    ɎgpȂƁB
;
;  {\tgEFÁA쌠҂ɂāû܂܁v񋟂Ă܂B쌠҂́A
;  ړIւ̓K̕ۏ؁Ai̕ۏ؁A܂Ɍ肳ȂAȂ閾
;  I͈ÖقȕۏؐӔC܂B쌠҂́AR̂킸AQ
;  ̌킸AӔC̍_ł邩iӔCł邩iߎ
;  ̑́js@sׂł邩킸Aɂ̂悤ȑQ\m
;  ĂƂĂA{\tgEFA̎gpɂĔi֕i܂͑pT
;  [rX̒BAgp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂
;  Ɍ肳ȂjڑQAԐڑQAIȑQAʑQAIQA
;  ͌ʑQɂāAؐӔC𕉂Ȃ̂Ƃ܂B
;
;  Note that above Japanese version license is the formal document.
;  The following translation is only for reference.
;
;  Redistribution and use of this software or any derivative works,
;  are permitted provided that the following conditions are met:
;
;  1. Redistributions of source code must retain the above copyright
;     notice, this list of conditions and the following disclaimer.
;  2. Redistributions in binary form must reproduce the above
;     copyright notice, this list of conditions and the following
;     disclaimer in the documentation and/or other materials
;     provided with the distribution.
;  3. Redistributions may not be sold, nor may they be used in a
;     commercial product or activity without specific prior written
;     permission.
;
;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
;  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
;  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
;  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
;  POSSIBILITY OF SUCH DAMAGE.
; ------------------------------------------------------------------------------
;	Date		Author	Ver		Description
;	2020/9/26	t.hara	1.0		1st release
; ==============================================================================

; ==============================================================================
;	kanji_init
;	tHg`惋[` page3 ֓]
;	input)
;		--
;	output)
;		--
;	break)
;		all
; ==============================================================================
		scope		kanji_init
kanji_init::
		; page3  kanji_driver ]
		ld			hl, kanji_driver_on_rom
		ld			de, kanji_driver_top
		ld			bc, kanji_driver_size
		ldir
		ret
		endscope

; ==============================================================================
kanji_driver_on_rom::
		org		kanji_driver
kanji_driver_top::

; ==============================================================================
;	draw_string
;	`悷
;	input)
;		hl .... `悷p^[WFl[^[e[ũAhX
;		de .... `悷镶 (MAX 30, ASCIIZ)
;	output)
;		a ..... 0: I[, 1`255: ̕ (kanji_work Ɏ܂Ȃ)
;	break)
;		all
; ==============================================================================
		scope	draw_string
draw_string::
		call	SETWRT
		call	put_string
		dec		b
		inc		b
		ret		z						;  0 Ȃ甲
		ld		c, vdp_port0
transfer_loop:
		outi
		jr		nz, transfer_loop		; OTIRƑ
		ret
		endscope

; ==============================================================================
;	put_string
;	input)
;		de .... `悷镶 (ASCIIZ), MAX62
;	output)
;		hl ........... kanji_work
;		kanji_work ... `悷镶
;		b ............ ]byte
;		a ............ ̕
; ==============================================================================
		scope	put_string
put_string::
		; Page1, Page2 J[gbW̃XbgɕύX
		push	de
		ld		h, 0x40
		ld		a, [my_slot_no]
		call	enaslt				; 
		ld		h, 0x80
		ld		a, [my_slot_no]
		call	enaslt				; 
		pop		de

		ld		hl, kanji_work
		xor		a, a				; Cy = 0
		ld		[rom_bank0], a		; HELP  e\ Bank#0 ɂ̂ŁABank0  Bank#0 ɖ߂Ă
loop:
		push	hl
		ld		bc, kanji_work_end
		sbc		hl, bc
		pop		hl
		jp		nc, exit_put_string	; I[ɓ
		or		a, a
		jp		nz, skip_4sft		; a = 0 Ȃ YȈʒu, 0 Ȃ 4hbgVtgʒu

		; YȈʒuɕ`
		push	hl
		call	put_kanji
		pop		hl
		or		a, a
		jp		z, exit_put_string_term
		dec		a
		dec		a
		jp		nz, loop			; p`悵ꍇ hl ͐i߂ a = -1 ɂ
		ld		bc, 8				; Sp`悵ꍇ hl i߂ a = 0 ɂ
		add		hl, bc				; Cy = 0
		jp		loop

skip_4sft:
		; 4hbgVtgʒuɕ`
		push	hl
		call	put_kanji_4sft
		pop		hl
		ld		bc, 8				; płSpł hl ͐i߂
		add		hl, bc				; pꍇYȈʒu ( a = 0 ) ɂ , ł Cy = 0
		or		a, a
		jp		z, exit_put_string_term
		dec		a
		jp		loop				; Spꍇ4hbgVtgʒu ( a = 1 ) ɂ

exit_put_string:
		ld		a, [de]				; ̕
exit_put_string_term:
		push	af
		push	hl
		ld		a, 0x3F
		ld		[scc_bank2], a		; Konami8K SCC ̏ꍇASCCWX^oĂBASCII8K ̏ꍇAӖ ROM  3Fh ށB
		ld		h, 0x40
		ld		a, [page1_slot]
		call	enaslt				; 
		ld		h, 0x80
		ld		a, [page2_slot]
		call	enaslt				; 
		ei
		pop		hl
		pop		af

		ld		de, kanji_work
		sbc		hl, de
		ld		b, l
		ex		de, hl
		ret
		endscope

; ==============================================================================
;	put_kanji
;	ꕶ`悷
;	input)
;		de ... i[ĂAhX (ShiftJIS)
;		hl ... `惁̃AhX
;	output)
;		de ... ̊̕i[AhX
;		a .... 0: I[
;		       1: p
;		       2: Sp
;	break)
;		all
; ==============================================================================
		scope	put_kanji
put_kanji::
		ld		[kanji_target_address], hl
		ld		a, [de]
		cp		a, ' '
		jp		nc, skip1
		xor		a, a
		ret
skip1:
		inc		de
		call	issjis1st
		jp		nc, put_half_size

		; Sp̕`
		cp		a, 0xE0
		jp		c, skip_pfs1
		sub		a, 0x40			; 0xE0..0xFF --> 0xA0..0xBF
skip_pfs1:
		cp		a, 0x88
		jp		c, skip_pfs2
		sub		a, 0x03			; 0x88..0xBF --> 0x85..0xBC
skip_pfs2:
		sub		a, 0x81			; A = 0x00..0x3A
		; 192{ = 3 * 64{  3{ 8bit zȂ
		ld		b, a
		add		a, a
		add		a, b
		ld		l, a
		ld		h, 0
		ld		b, h
		ld		c, 159
		add		hl, hl
		add		hl, hl
		add		hl, hl
		add		hl, hl
		add		hl, hl
		add		hl, hl
		add		hl, bc
		; 2byte
		ld		a, [de]
		inc		de
		push	de
		sub		a, 0x40
		ld		c, a
		add		hl, bc
		; 18byte
		add		hl, hl
		add		hl, hl
		add		hl, hl
		push	hl
		; KvȃoN(HL̏3bit)ɐ؂ւ
		ld		a, h
		rlca
		rlca
		rlca
		and		a, 0b0000_0111
		add		a, KANJI_BANK
		ld		[rom_bank2], a
		; oNAhX߂
		pop		hl
		ld		a, h
		and		a, 0b0001_1111
		or		a, 0x80
		ld		h, a
		ld		de, [kanji_target_address]
		ld		a, 2
		jp		transfer
		; p̕`
put_half_size:
		push	de
		; 32`127, 161`223  0`158 ɕϊ
		sub		a, 32
		cp		a, 96
		jr		c, skip_phs1
		sub		a, 33
skip_phs1:
		ex		de, hl
		; AhXɕϊ
		ld		l, a
		ld		h, 0
		add		hl, hl
		add		hl, hl
		add		hl, hl
		ld		a, KANJI_BANK
		ld		[rom_bank2], a
		ld		a, 0x80
		add		a, h
		ld		h, a
		ld		a, 1
transfer:
		ldi
		ldi
		ldi
		ldi
		ldi
		ldi
		ldi
		ldi
		pop		de
		ret
		endscope

; ==============================================================================
;	put_kanji_4sft
;	ꕶ`悷 (4fVtg)
;	input)
;		de ... i[ĂAhX (ShiftJIS)
;		hl ... `惁̃AhX
;	output)
;		de ... ̊̕i[AhX
;		a .... 0: I[
;		       1: p
;		       2: Sp
;	break)
;		all
; ==============================================================================
		scope	put_kanji_4sft
put_kanji_4sft::
		ld		[kanji_target_address], hl
		ld		a, [de]
		cp		a, ' '
		jp		nc, skip1
		xor		a, a
		ret
skip1:
		inc		de
		call	issjis1st
		jp		nc, put_half_size

		; Sp̕`
		cp		a, 0xE0
		jp		c, skip_pfs1
		sub		a, 0x40			; 0xE0..0xFF --> 0xA0..0xBF
skip_pfs1:
		cp		a, 0x88
		jp		c, skip_pfs2
		sub		a, 0x03			; 0x88..0xBF --> 0x85..0xBC
skip_pfs2:
		sub		a, 0x81			; A = 0x00..0x3A
		; 192{ = 3 * 64{  6{ 8bit zȂ
		ld		b, a
		add		a, a
		add		a, b
		ld		l, a
		ld		h, 0
		ld		b, h
		ld		c, 159
		add		hl, hl
		add		hl, hl
		add		hl, hl
		add		hl, hl
		add		hl, hl
		add		hl, hl
		add		hl, bc
		; 2byte
		ld		a, [de]
		inc		de
		push	de
		sub		a, 0x40
		ld		c, a
		add		hl, bc
		; 18byte
		add		hl, hl
		add		hl, hl
		add		hl, hl
		push	hl
		; KvȃoN(HL̏3bit)ɐ؂ւ
		ld		a, h
		rlca
		rlca
		rlca
		and		a, 0b0000_0111
		add		a, KANJI_BANK
		ld		[rom_bank2], a
		; oNAhX߂
		pop		hl
		ld		a, h
		and		a, 0b0001_1111
		or		a, 0x80
		ld		h, a
		ld		de, [kanji_target_address]
		; ̕`
		push	hl
		ld		b, 8
loop_pfs1:
		ld		a, [hl]
		rrca
		rrca
		rrca
		rrca
		and		a, 0x0F
		ex		de, hl
		or		a, [hl]
		ld		[hl], a
		ex		de, hl
		inc		hl
		inc		de
		djnz	loop_pfs1
		pop		hl
		; E̕`
		ld		b, 8
loop_pfs2:
		ld		a, [hl]
		rrca
		rrca
		rrca
		rrca
		and		a, 0xF0
		ld		[de], a
		inc		hl
		inc		de
		djnz	loop_pfs2
		pop		de
		ld		a, 2
		ret

		; p̕`
put_half_size:
		push	de
		; 32`127, 161`223  0`158 ɕϊ
		sub		a, 32
		cp		a, 96
		jr		c, skip_phs1
		sub		a, 33
skip_phs1:
		ex		de, hl
		; AhXɕϊ
		ld		l, a
		ld		h, 0
		add		hl, hl
		add		hl, hl
		add		hl, hl
		ld		a, KANJI_BANK
		ld		[rom_bank2], a
		ld		a, 0x80
		add		a, h
		ld		h, a
		ld		b, 8
loop_phs1:
		ld		a, [hl]
		rrca
		rrca
		rrca
		rrca
		and		a, 0x0F
		ex		de, hl
		or		a, [hl]
		ld		[hl], a
		ex		de, hl
		inc		hl
		inc		de
		djnz	loop_phs1
		pop		de
		ld		a, 1
		ret
		endscope

; ==============================================================================
;	issjis1st
;	input)
;		a ..... Character code
;	output)
;		Cy .... 0: ASCIIR[h/ȕR[h, 1: }`oCg1byte
;	break)
;		f
;	comment)
;		R[h A AShiftJIS ̃}`oCg1byteڂǂ𔻒肷
; ==============================================================================
		scope	issjis1st
issjis1st::
		or		a, a
		ret		p			; 0`127  ASCIIR[h
		cp		a, 161
		ret		c			; 128`160  }`oCg1byte
		cp		a, 224
		ccf					; 161`223  ȕR[h, 224`255 ̓}`oCg1byte
		ret
		endscope

kanji_target_address:
		dw		0

grp_draw_file_line::
sort_song_title1::
		space	64
sort_song_title2::
		space	64
target_file_name::				; Ȗ\(XN[)̂߂ɁAȖێ̈
		space		128
target_file_name_end::
		db			0, 0

kanji_driver_bottom::
kanji_driver_size	:= kanji_driver_bottom - kanji_driver_top
		org		kanji_driver_on_rom + kanji_driver_size
